screen lewd_selection(character_data):
    #zorder 101
    default chapters = character_data["chapters"]
    default num_columns = character_data.get("num_columns", 5)  # Dynamically use the defined number of columns
    default x_max = character_data.get("x_max", 200)
    default y_max = character_data.get("y_max", 200)
    default x_padding = character_data.get("x_padding", 20)
    default text_size = character_data.get("text_size", 30)
    default brightness_value = character_data.get("brightness_value", 0.2)

    
    add "dim" 
    add "dim"  
    add "dim"  
    add "dim"  
    add "dim"  
    add "dim"  
    add "dim"  
    # Set the grid to have a single row and multiple columns
    grid num_columns 1:
        xpos 40
        ypos 150
        for chapter in chapters:
            
            # Check if the chapter is unlocked before showing it
            if Patreon == False and chapter["Patreon"] == True:
                $ cover_patreon = chapter["image"].replace(".png", "_patreon.png")
                frame:
                    background None  # No background for the frame
                    xpadding x_padding  # Padding inside the frame
                    ypadding 10  # Padding inside the frame

                    vbox:
                        # Image button that crops the center portion of the image
                        imagebutton:
                            # Crop the image based on a center-focused logic
                            idle im.Blur(im.FactorScale(cover_patreon,0.2),0.60)
         
                            hover im.Blur(
                                im.MatrixColor(
                                im.FactorScale(cover_patreon,0.2),
                                im.matrix.brightness(brightness_value),
                            ),
                            0.60)

                            hover_sound "sounds/tile.mp3"
                            action OpenURL("https://www.patreon.com/shiro_game_studios")
            elif chapter["unlocked"] or Cheats:
                frame:
                    background None  # No background for the frame
                    xpadding x_padding  # Padding inside the frame
                    ypadding 10  # Padding inside the frame

                    vbox:
                        # Image button that crops the center portion of the image
                        imagebutton:
                            # Crop the image based on a center-focused logic
                            idle im.FactorScale(chapter["image"],0.2)
         
                            hover im.MatrixColor(
                                im.FactorScale(chapter["image"],0.2),
                                im.matrix.brightness(brightness_value),
                            )
                            hover_sound "sounds/tile.mp3"

                            action (SetVariable("lewd_scene",chapter["scene"]),Hide("lewd_selection"), Call("ShowLewdScene"))

                        # Centered chapter name below each button
                        #text chapter["lewd_name"] xalign 0.5 ypos 20 bold True size text_size
            else:
                frame:
                    background None  # No background for the frame
                    xpadding x_padding  # Padding inside the frame
                    ypadding 10  # Padding inside the frame

                    vbox:
                        # Image button that crops the center portion of the image
                        imagebutton:
                            # Crop the image based on a center-focused logic
                            idle im.Blur(im.FactorScale(chapter["image"],0.2),0.60)
         
                            hover im.Blur(
                                im.MatrixColor(
                                im.FactorScale(chapter["image"],0.2),
                                im.matrix.brightness(brightness_value),
                            ),
                            0.60)

                            hover_sound "sounds/tile.mp3"
                            action  Hide("lewd_selection"),Call("quest_gate")

    # Frame for the Close button at the bottom
    frame:
        maximum(400, 100)
        style "game_over_frame"
        align (0.02, 0.02)
        vbox:
            button:
                xalign 0.5
                text "CLOSE" bold True
                action Hide("lewd_selection"), SetVariable("sens",True), Show("map")


label NoPatreon:
    "Replaying Scenes is only avaiable in {a=https://www.patreon.com/shiro_game_studios}{b}{color=#f00}Patreon{/color}{/b}{/a} version."
    $ sens = True
    show screen map
    $ ui.interact()
    return